import time
import sys
import math
#
from System.Collections.Generic import List
from System import Byte, Int32
#
Direction = Player.Direction
CropIds = List[int]([ 0x0C4F, 0x0C50, 0x0CC6, 0x0C7C ])

def PickCrops():
    findCrop = Items.Filter()
    findCrop.Enabled = True
    findCrop.OnGround = 1
    findCrop.Movable = False
    findCrop.RangeMin = -1
    findCrop.RangeMax = 3
    findCrop.Graphics = CropIds
    findCrop.CheckIgnoreObject = True
    listCrop = Items.ApplyFilter(findCrop)
    for crop in listCrop:
        Items.UseItem(crop)         
        if len(Player.Backpack.Contains) > 120 or Player.Weight > 530 :
            StoreItems()
        else:
            Misc.Pause(500)    
#
def StoreItems():
    Misc.WaitForContext(0x425A36A8, 10000)
    Misc.ContextReply(0x425A36A8, 2)
    Gumps.WaitForGump(111922706, 10000)
    Gumps.SendAction(111922706, 0)
    #
    Misc.WaitForContext(0x41CE0B76, 10000)
    Misc.ContextReply(0x41CE0B76, 2)
    Gumps.WaitForGump(111922706, 10000)
    Gumps.SendAction(111922706, 0)  

    if Misc.CheckSharedValue("BagOfHolding"):
        BOH = Misc.ReadSharedValue("BagOfHolding")    
        cotton = Items.FindByID (0x0DF9, -1, Player.Backpack.Serial)
        if cotton is not None:
            Items.Move(cotton, BOH, -1)
            Misc.Pause(1000)

#
def DoRow():
    Journal.Clear()
    PickCrops()
    while Journal.Search("You do not manage"):
        Misc.SendMessage("RETRYING", 5)
        Journal.Clear()
        PickCrops() 
    #
    StoreItems()
    #        
    #
    MotionMap = {
             "North": (0, -1), 
             "Right": (+1, -1),
             "East": (+1, 0),
             "Down": (+1, +1),
             "South": (0, +1),
             "Left": (-1, +1),
             "West": (-1, 0),
             "Up": (-1, -1),
             "North": (0, -1), 
             "Right": (+1, -1),
             "East": (+1, 0),
             "Down": (+1, +1),
             "South": (0, +1),
             "Left": (-1, +1),
             "West": (-1, 0),
             "Up": (-1, -1),
             } 
    # 
    TurnLeftMap = {
        "North": "West",
        "West": "South",
        "South": "East",
        "East": "North",
        }            
    if Player.Direction != Direction:
        Player.Walk(Direction)
    for step in range(7):    
        x_delta, y_delta = MotionMap[Player.Direction]
        x = Player.Position.X + x_delta
        y = Player.Position.Y + y_delta
        land_id = Statics.GetLandID(x, y, Player.Map)
        Misc.SendMessage("X: {} Y: {} LandID: 0x{:x} ImPassable: {}".format(x, y, land_id, Statics.GetLandFlag(land_id, "Impassable")))
        if land_id != 0x9:
            return False
        Player.Walk(Direction)    
    return True

while DoRow():
    pass
DoRow()    